 SECIND     EQU 3               ; Indentifier of sector size.
 SECTORS    EQU 5               ; Sectors on track (one side).
 TRACKS     EQU 80              ; Tracks on drive (two sided).
 SECSIZE    EQU 400h            ; Sector length in bytes.
 QUITKEY    EQU 44h             ; Break emulation keystroke.
 RSTKEY     EQU 43h             ; Restart machine keystroke.
 NOQ        EQU 80h             ; Quit flag code.
 NOR        EQU 40h             ; Reset flag code.
 NOE        EQU 4h              ; No such instruction code.
 NOM        EQU 2h              ; No such memory model.
 SOFT       EQU 1h              ; Software interrupt.

 UNION Ri                       ; Structure of register
  STRUC
   l         DB ?
   h         DB ?
  ENDS
   x         DW ?
 ENDS

 STRUC Treg
   afr       Ri ?
   bcr       Ri ?
   der       Ri ?
   hlr       Ri ?
   spr       Ri ?
   pcr       Ri ?
 ENDS

 STRUC Tint
   inta      DW ?
   intmsk    DB ?
   intirp    DB ?
   intisr    DB ?
   stat      DB ?
   iff       DB ?
 ENDS

 STRUC Ttim
   ce        DW ?
   cr        DW ?
   cw        DW ?
   com       DB ?
   state     DB ?
 ENDS

 STRUC Tsys
   Lutset    DB 10h   DUP(?)
   Color     DB ?
   sysreg    DB ?
 ENDS

 STRUC T8255
   a         DB ?
   b         DB ?
   c         DB ?
   mode      DB ?
 ENDS

 STRUC T8251
   data      DB ?
  ;com       DB ?
  ;stat      DB ?
 ENDS

 STRUC Tind
   track     DB ?
   side      DB ?
   sector    DB ?
   seclen    DB ?
 ENDS

 STRUC Tfdc
   com       DB ?
   state     DB ?
   track     DB ?
   sector    DB ?
   data      DB ?
   mark      DW ?
   count     DB ?
   direct    DB ?
   handle    DW ?
   ind       Tind ?
   buffer    DB SECSIZE DUP(?)
 ENDS
