; INSTRUCTIONS INTEL8080 EMULATION
; Include into korvet.asm

; Registers map:
; (A,F)  -  (AL, AH)
; (B,C)  -    (BP)
; (D,E)  -  (CH, CL)
; (H,L)  -  (DH, DL)
; (SP)   -    (SI)
; (PC)   -    (DI)
; (RAM)  -    (DS)
; (ROM)  -    (ES)
; free   -    (BX)

 PROC rword                     ; Read word at address.
            call [cs:rb]        ;  in: di - address
            mov  bl,bh          ; out: bx - data
            jmp  [cs:rb]        ;      di=di+2
           EVEN
 ENDP

 PROC wword                     ; Write word at address.
            xchg bh,bl          ;  in: di - address
            call [cs:wb]        ;      bx - data
            xchg bh,bl          ; out: di=di+2
            jmp  [cs:wb]
           EVEN
 ENDP

 PROC com
            cmp  [es:breac],0
            jnz  @@isr
  Critical: call [cs:rb]
            mov  bl,bh
            xor  bh,bh
            shl  bx,1
            jmp  [cs:bx+@@i]
           EVEN
  @@isr:    xor  bl,bl
            xchg [es:breac],bl
            cmp  bl,SOFT
            jz   @@soft
            test bl,NOR
            jnz  @@rst
            jmp  Finish
   @@rst:   jmp  Reset
  @@soft:   push ax
            mov  ax,100h
            mov  bh,[es:Icon.intirp]
            mov  bl,[es:Icon.intisr]
  @@lp:     test bl,ah
            jnz  @@ex
            shr  bh,1
            jc   @@un
            add  al,4
            shl  ah,1
            jnc  @@lp
  @@ex:     pop  ax
            jmp  Critical
  @@un:     or   [es:Icon.intisr],ah
            sub  [es:Icon.intirp],ah
            mov  bx,[es:Icon.inta]
            mov  [es:Icon.iff],0
            xor  ah,ah
            test bl,4h
            jnz  @@dbl
            shl  al,1
  @@dbl:    and  bl,0E0h
            add  bx,ax
            pop  ax
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
           EVEN
   @@noi:   dec di
            or  [es:breac],NOE
            jmp @@isr
           EVEN
   @@i     dw offset i_nop        ;00
           dw offset i_lxi_b      ;01
           dw offset i_stax_b     ;02
           dw offset i_inx_b      ;03
           dw offset i_inr_b      ;04
           dw offset i_dcr_b      ;05
           dw offset i_mvi_b      ;06
           dw offset i_rlc        ;07
           dw offset @@noi        ;08
           dw offset i_dad_b      ;09
           dw offset i_ldax_b     ;0A
           dw offset i_dcx_b      ;0B
           dw offset i_inr_c      ;0C
           dw offset i_dcr_c      ;0D
           dw offset i_mvi_c      ;0E
           dw offset i_rrc        ;0F
           dw offset @@noi        ;10
           dw offset i_lxi_d      ;11
           dw offset i_stax_d     ;12
           dw offset i_inx_d      ;13
           dw offset i_inr_d      ;14
           dw offset i_dcr_d      ;15
           dw offset i_mvi_d      ;16
           dw offset i_ral        ;17
           dw offset @@noi        ;18
           dw offset i_dad_d      ;19
           dw offset i_ldax_d     ;1A
           dw offset i_dcx_d      ;1B
           dw offset i_inr_e      ;1C
           dw offset i_dcr_e      ;1D
           dw offset i_mvi_e      ;1E
           dw offset i_rar        ;1F
           dw offset @@noi        ;20
           dw offset i_lxi_h      ;21
           dw offset i_shld       ;22
           dw offset i_inx_h      ;23
           dw offset i_inr_h      ;24
           dw offset i_dcr_h      ;25
           dw offset i_mvi_h      ;26
           dw offset i_daa        ;27
           dw offset @@noi        ;28
           dw offset i_dad_h      ;29
           dw offset i_lhld       ;2A
           dw offset i_dcx_h      ;2B
           dw offset i_inr_l      ;2C
           dw offset i_dcr_l      ;2D
           dw offset i_mvi_l      ;2E
           dw offset i_cma        ;2F
           dw offset @@noi        ;30
           dw offset i_lxi_sp     ;31
           dw offset i_sta        ;32
           dw offset i_inx_sp     ;33
           dw offset i_inr_m      ;34
           dw offset i_dcr_m      ;35
           dw offset i_mvi_m      ;36
           dw offset i_stc        ;37
           dw offset @@noi        ;38
           dw offset i_dad_sp     ;39
           dw offset i_lda        ;3A
           dw offset i_dcx_sp     ;3B
           dw offset i_inr_a      ;3C
           dw offset i_dcr_a      ;3D
           dw offset i_mvi_a      ;3E
           dw offset i_cmc        ;3F
           dw offset i_nop        ;40
           dw offset i_mov_bc     ;41
           dw offset i_mov_bd     ;42
           dw offset i_mov_be     ;43
           dw offset i_mov_bh     ;44
           dw offset i_mov_bl     ;45
           dw offset i_mov_bm     ;46
           dw offset i_mov_ba     ;47
           dw offset i_mov_cb     ;48
           dw offset i_nop        ;49
           dw offset i_mov_cd     ;4A
           dw offset i_mov_ce     ;4B
           dw offset i_mov_ch     ;4C
           dw offset i_mov_cl     ;4D
           dw offset i_mov_cm     ;4E
           dw offset i_mov_ca     ;4F
           dw offset i_mov_db     ;50
           dw offset i_mov_dc     ;51
           dw offset i_nop        ;52
           dw offset i_mov_de     ;53
           dw offset i_mov_dh     ;54
           dw offset i_mov_dl     ;55
           dw offset i_mov_dm     ;56
           dw offset i_mov_da     ;57
           dw offset i_mov_eb     ;58
           dw offset i_mov_ec     ;59
           dw offset i_mov_ed     ;5A
           dw offset i_nop        ;5B
           dw offset i_mov_eh     ;5C
           dw offset i_mov_el     ;5D
           dw offset i_mov_em     ;5E
           dw offset i_mov_ea     ;5F
           dw offset i_mov_hb     ;60
           dw offset i_mov_hc     ;61
           dw offset i_mov_hd     ;62
           dw offset i_mov_he     ;63
           dw offset i_nop        ;64
           dw offset i_mov_hl     ;65
           dw offset i_mov_hm     ;66
           dw offset i_mov_ha     ;67
           dw offset i_mov_lb     ;68
           dw offset i_mov_lc     ;69
           dw offset i_mov_ld     ;6A
           dw offset i_mov_le     ;6B
           dw offset i_mov_lh     ;6C
           dw offset i_nop        ;6D
           dw offset i_mov_lm     ;6E
           dw offset i_mov_la     ;6F
           dw offset i_mov_mb     ;70
           dw offset i_mov_mc     ;71
           dw offset i_mov_md     ;72
           dw offset i_mov_me     ;73
           dw offset i_mov_mh     ;74
           dw offset i_mov_ml     ;75
           dw offset i_hlt        ;76
           dw offset i_mov_ma     ;77
           dw offset i_mov_ab     ;78
           dw offset i_mov_ac     ;79
           dw offset i_mov_ad     ;7A
           dw offset i_mov_ae     ;7B
           dw offset i_mov_ah     ;7C
           dw offset i_mov_al     ;7D
           dw offset i_mov_am     ;7E
           dw offset i_nop        ;7F
           dw offset i_add_b      ;80
           dw offset i_add_c      ;81
           dw offset i_add_d      ;82
           dw offset i_add_e      ;83
           dw offset i_add_h      ;84
           dw offset i_add_l      ;85
           dw offset i_add_m      ;86
           dw offset i_add_a      ;87
           dw offset i_adc_b      ;88
           dw offset i_adc_c      ;89
           dw offset i_adc_d      ;8A
           dw offset i_adc_e      ;8B
           dw offset i_adc_h      ;8C
           dw offset i_adc_l      ;8D
           dw offset i_adc_m      ;8E
           dw offset i_adc_a      ;8F
           dw offset i_sub_b      ;90
           dw offset i_sub_c      ;91
           dw offset i_sub_d      ;92
           dw offset i_sub_e      ;93
           dw offset i_sub_h      ;94
           dw offset i_sub_l      ;95
           dw offset i_sub_m      ;96
           dw offset i_sub_a      ;97
           dw offset i_sbb_b      ;98
           dw offset i_sbb_c      ;99
           dw offset i_sbb_d      ;9A
           dw offset i_sbb_e      ;9B
           dw offset i_sbb_h      ;9C
           dw offset i_sbb_l      ;9D
           dw offset i_sbb_m      ;9E
           dw offset i_sbb_a      ;9F
           dw offset i_ana_b      ;A0
           dw offset i_ana_c      ;A1
           dw offset i_ana_d      ;A2
           dw offset i_ana_e      ;A3
           dw offset i_ana_h      ;A4
           dw offset i_ana_l      ;A5
           dw offset i_ana_m      ;A6
           dw offset i_ana_a      ;A7
           dw offset i_xra_b      ;A8
           dw offset i_xra_c      ;A9
           dw offset i_xra_d      ;AA
           dw offset i_xra_e      ;AB
           dw offset i_xra_h      ;AC
           dw offset i_xra_l      ;AD
           dw offset i_xra_m      ;AE
           dw offset i_xra_a      ;AF
           dw offset i_ora_b      ;B0
           dw offset i_ora_c      ;B1
           dw offset i_ora_d      ;B2
           dw offset i_ora_e      ;B3
           dw offset i_ora_h      ;B4
           dw offset i_ora_l      ;B5
           dw offset i_ora_m      ;B6
           dw offset i_ora_a      ;B7
           dw offset i_cmp_b      ;B8
           dw offset i_cmp_c      ;B9
           dw offset i_cmp_d      ;BA
           dw offset i_cmp_e      ;BB
           dw offset i_cmp_h      ;BC
           dw offset i_cmp_l      ;BD
           dw offset i_cmp_m      ;BE
           dw offset i_cmp_a      ;BF
           dw offset i_rnz        ;C0
           dw offset i_pop_b      ;C1
           dw offset i_jnz        ;C2
           dw offset i_jmp        ;C3
           dw offset i_cnz        ;C4
           dw offset i_push_b     ;C5
           dw offset i_adi        ;C6
           dw offset i_rst0       ;C7
           dw offset i_rz         ;C8
           dw offset i_ret        ;C9
           dw offset i_jz         ;CA
           dw offset @@noi        ;CB
           dw offset i_cz         ;CC
           dw offset i_call       ;CD
           dw offset i_aci        ;CE
           dw offset i_rst1       ;CF
           dw offset i_rnc        ;D0
           dw offset i_pop_d      ;D1
           dw offset i_jnc        ;D2
           dw offset i_out        ;D3
           dw offset i_cnc        ;D4
           dw offset i_push_d     ;D5
           dw offset i_sui        ;D6
           dw offset i_rst2       ;D7
           dw offset i_rc         ;D8
           dw offset @@noi        ;D9
           dw offset i_jc         ;DA
           dw offset i_in         ;DB
           dw offset i_cc         ;DC
           dw offset @@noi        ;DD
           dw offset i_sbi        ;DE
           dw offset i_rst3       ;DF
           dw offset i_rpo        ;E0
           dw offset i_pop_h      ;E1
           dw offset i_jpo        ;E2
           dw offset i_xthl       ;E3
           dw offset i_cpo        ;E4
           dw offset i_push_h     ;E5
           dw offset i_ani        ;E6
           dw offset i_rst4       ;E7
           dw offset i_rpe        ;E8
           dw offset i_pchl       ;E9
           dw offset i_jpe        ;EA
           dw offset i_xchg       ;EB
           dw offset i_cpe        ;EC
           dw offset @@noi        ;ED
           dw offset i_xri        ;EE
           dw offset i_rst5       ;EF
           dw offset i_rp         ;F0
           dw offset i_pop_msw    ;F1
           dw offset i_jp         ;F2
           dw offset i_di         ;F3
           dw offset i_cp         ;F4
           dw offset i_push_msw   ;F5
           dw offset i_ori        ;F6
           dw offset i_rst6       ;F7
           dw offset i_rm         ;F8
           dw offset i_sphl       ;F9
           dw offset i_jm         ;FA
           dw offset i_ei         ;FB
           dw offset i_cm         ;FC
           dw offset @@noi        ;FD
           dw offset i_cpi        ;FE
           dw offset i_rst7       ;FF
 ENDP

; /// ****************************************************************** ///
 PROC i_nop                     ;NOP        00
            jmp  com
 ENDP
 PROC i_lxi_b                   ;LXI B,nn   01
            call rword
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_stax_b                  ;STAX B     02
            push di
            mov  di,bp
            mov  bh,al
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_inx_b                   ;INX B      03
            inc  bp
            jmp  com
 ENDP
 PROC i_inr_b                   ;INR B      04
            mov  bx,bp
            sahf
            inc  bh
            lahf
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_dcr_b                   ;DCR B      05
            mov  bx,bp
            sahf
            dec  bh
            lahf
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mvi_b                   ;MVI B,n    06
            mov  bx,bp
            call [cs:rb]
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_rlc                     ;RLC        07
            sahf
            rol  al,1
            lahf
            jmp  com
 ENDP
 PROC i_dad_b                   ;DAD B      09
            shr  ah,1
            add  dx,bp
            rcl  ah,1
            jmp  com
 ENDP
 PROC i_ldax_b                  ;LDAX B     0A
            push di
            mov  di,bp
            call [cs:rb]
            mov  al,bh
            pop  di
            jmp  com
 ENDP
 PROC i_dcx_b                   ;DCX B      0B
            dec  bp
            jmp  com
 ENDP
 PROC i_inr_c                   ;INR C      0C
            mov  bx,bp
            sahf
            inc  bl
            lahf
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_dcr_c                   ;DCR C      0D
            mov  bx,bp
            sahf
            dec  bl
            lahf
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mvi_c                   ;MVI C,n    0E
            call [cs:rb]
            xchg ax,bp
            mov  al,bh
            xchg ax,bp
            jmp  com
 ENDP
 PROC i_rrc                     ;RRC        0F
            sahf
            ror  al,1
            lahf
            jmp  com
 ENDP
 PROC i_lxi_d                   ;LXI D,nn   11
            call rword
            mov  cx,bx
            jmp  com
 ENDP
 PROC i_stax_d                  ;STAX D     12
            push di
            mov  di,cx
            mov  bh,al
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_inx_d                   ;INX D      13
            inc  cx
            jmp  com
 ENDP
 PROC i_inr_d                   ;INR D      14
            sahf
            inc  ch
            lahf
            jmp  com
 ENDP
 PROC i_dcr_d                   ;DCR D      15
            sahf
            dec  ch
            lahf
            jmp  com
 ENDP
 PROC i_mvi_d                   ;MVI  D,n   16
            call [cs:rb]
            mov  ch,bh
            jmp  com
 ENDP
 PROC i_ral                     ;RAL        17
            sahf
            rcl  al,1
            lahf
            jmp  com
 ENDP
 PROC i_dad_d                   ;DAD D      19
            shr  ah,1
            add  dx,cx
            rcl  ah,1
            jmp  com
 ENDP
 PROC i_ldax_d                  ;LDAX D     1A
            push di
            mov  di,cx
            call [cs:rb]
            mov  al,bh
            pop  di
            jmp  com
 ENDP
 PROC i_dcx_d                   ;DCX D      1B
            dec  cx
            jmp  com
 ENDP
 PROC i_inr_e                   ;INR E      1C
            sahf
            inc  cl
            lahf
            jmp  com
 ENDP
 PROC i_dcr_e                   ;DCR E       1D
            sahf
            dec  cl
            lahf
            jmp  com
 ENDP
 PROC i_mvi_e                   ;MVI E,n    1E
            call [cs:rb]
            mov  cl,bh
            jmp  com
 ENDP
 PROC i_rar                     ;RAR        1F
            sahf
            rcr  al,1
            lahf
            jmp  com
 ENDP
 PROC i_lxi_h                   ;LXI H,nn   21
            call rword
            mov  dx,bx
            jmp  com
 ENDP
 PROC i_shld                    ;SHLD nn    22
            call rword
            push di
            mov  di,bx
            mov  bx,dx
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_inx_h                   ;INX H      23
            inc  dx
            jmp  com
 ENDP
 PROC i_inr_h                   ;INR H      24
            sahf
            inc  dh
            lahf
            jmp  com
 ENDP
 PROC i_dcr_h                   ;DCR H      25
            sahf
            dec  dh
            lahf
            jmp  com
 ENDP
 PROC i_mvi_h                   ;MVI H,n    26
            call [cs:rb]
            mov  dh,bh
            jmp  com
 ENDP
 PROC i_daa                     ;DAA        27  (flags ?)
            sahf
            daa
            lahf
            jmp  com
 ENDP
 PROC i_dad_h                   ;DAD H      29
            shr  ah,1
            add  dx,dx
            rcl  ah,1
            jmp  com
 ENDP
 PROC i_lhld                    ;LHLD nn    2A
            call rword
            push di
            mov  di,bx
            call rword
            mov  dx,bx
            pop  di
            jmp  com
 ENDP
 PROC i_dcx_h                   ;DCX H      2B
            dec  dx
            jmp  com
 ENDP
 PROC i_inr_l                   ;INR L      2C
            sahf
            inc  dl
            lahf
            jmp  com
 ENDP
 PROC i_dcr_l                   ;DCR L      2D
            sahf
            dec  dl
            lahf
            jmp  com
 ENDP
 PROC i_mvi_l                   ;MVI L,n    2E
            call [cs:rb]
            mov  dl,bh
            jmp  com
 ENDP
 PROC i_cma                     ;CMA        2F  (flags ?)
            not  al
            jmp  com
 ENDP
 PROC i_lxi_sp                  ;LXI SP,nn  31
            call rword
            mov  si,bx
            jmp  com
 ENDP
 PROC i_sta                     ;STA nn     32
            call rword
            push di
            mov  di,bx
            mov  bh,al
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_inx_sp                  ;INX SP     33
            inc  si
            jmp  com
 ENDP
 PROC i_inr_m                   ;INR M      34
            push di
            mov  di,dx
            call [cs:rb]
            sahf
            inc  bh
            lahf
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_dcr_m                   ;DCR M      35
            push di
            mov  di,dx
            call [cs:rb]
            sahf
            dec  bh
            lahf
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_mvi_m                   ;MVI M,n    36
            call [cs:rb]
            push di
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_stc                     ;STC        37
            or  ah,1
            jmp  com
 ENDP
 PROC i_dad_sp                  ;DAD SP     39
            shr  ah,1
            add  dx,si
            rcl  ah,1
            jmp  com
 ENDP
 PROC i_lda                     ;LDA nn     3A
            call rword
            push di
            mov  di,bx
            call [cs:rb]
            mov  al,bh
            pop  di
            jmp  com
 ENDP
 PROC i_dcx_sp                  ;DCX SP     3B
            dec  si
            jmp  com
 ENDP
 PROC i_inr_a                   ;INR A      3C
            sahf
            inc  al
            lahf
            jmp  com
 ENDP
 PROC i_dcr_a                   ;DCR A      3D
            sahf
            dec  al
            lahf
            jmp  com
 ENDP
 PROC i_mvi_a                   ;MVI A,n    3E
            call [cs:rb]
            mov  al,bh
            jmp  com
 ENDP
 PROC i_cmc                     ;CMC        3F
            xor  ah,1
            jmp  com
 ENDP
 PROC i_mov_bc                  ;MOV B,C    41
            mov  bx,bp
            mov  bh,bl
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_bd                  ;MOV B,D    42
            mov  bx,bp
            mov  bh,ch
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_be                  ;MOV B,E    43
            mov  bx,bp
            mov  bh,cl
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_bh                  ;MOV B,H    44
            mov  bx,bp
            mov  bh,dh
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_bl                  ;MOV B,L    45
            mov  bx,bp
            mov  bh,dl
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_bm                  ;MOV B,M    46
            push di
            mov  di,dx
            mov  bx,bp
            call [cs:rb]
            mov  bp,bx
            pop  di
            jmp  com
 ENDP
 PROC i_mov_ba                  ;MOV B,A    47
            mov  bx,bp
            mov  bh,al
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_cb                  ;MOV C,B    48
            mov  bx,bp
            mov  bl,bh
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_cd                  ;MOV C,D    4A
            mov  bx,bp
            mov  bl,ch
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_ce                  ;MOV C,E    4B
            mov  bx,bp
            mov  bl,cl
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_ch                  ;MOV C,H    4C
            mov  bx,bp
            mov  bl,dh
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_cl                  ;MOV C,L    4D
            mov  bx,bp
            mov  bl,dl
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_cm                  ;MOV C,M    4E
            push di
            mov  di,dx
            call [cs:rb]
            xchg ax,bp
            mov  al,bh
            xchg ax,bp
            pop  di
            jmp  com
 ENDP
 PROC i_mov_ca                  ;MOV C,A    4F
            mov  bx,bp
            mov  bl,al
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_mov_db                  ;MOV D,B    50
            mov  bx,bp
            mov  ch,bh
            jmp  com
 ENDP
 PROC i_mov_dc                  ;MOV D,C    51
            mov  bx,bp
            mov  ch,bl
            jmp  com
 ENDP
 PROC i_mov_de                  ;MOV D,E    53
            mov  ch,cl
            jmp  com
 ENDP
 PROC i_mov_dh                  ;MOV D,H    54
            mov  ch,dh
            jmp  com
 ENDP
 PROC i_mov_dl                  ;MOV D,L    55
            mov  ch,dl
            jmp  com
 ENDP
 PROC i_mov_dm                  ;MOV D,M    56
            push di
            mov  di,dx
            call [cs:rb]
            mov  ch,bh
            pop  di
            jmp  com
 ENDP
 PROC i_mov_da                  ;MOV D,A    57
            mov  ch,al
            jmp  com
 ENDP
 PROC i_mov_eb                  ;MOV E,B    58
            mov  bx,bp
            mov  cl,bh
            jmp  com
 ENDP
 PROC i_mov_ec                  ;MOV E,C    59
            mov  bx,bp
            mov  cl,bl
            jmp  com
 ENDP
 PROC i_mov_ed                  ;MOV E,D    5A
            mov  cl,ch
            jmp  com
 ENDP
 PROC i_mov_eh                  ;MOV E,H    5C
            mov  cl,dh
            jmp  com
 ENDP
 PROC i_mov_el                  ;MOV E,L    5D
            mov  cl,dl
            jmp  com
 ENDP
 PROC i_mov_em                  ;MOV E,M    5E
            push di
            mov  di,dx
            call [cs:rb]
            mov  cl,bh
            pop  di
            jmp  com
 ENDP
 PROC i_mov_ea                  ;MOV E,A    5F
            mov  cl,al
            jmp  com
 ENDP
 PROC i_mov_hb                  ;MOV H,B    60
            mov  bx,bp
            mov  dh,bh
            jmp  com
 ENDP
 PROC i_mov_hc                  ;MOV H,C    61
            mov  bx,bp
            mov  dh,bl
            jmp  com
 ENDP
 PROC i_mov_hd                  ;MOV H,D    62
            mov  dh,ch
            jmp  com
 ENDP
 PROC i_mov_he                  ;MOV H,E    63
            mov  dh,cl
            jmp  com
 ENDP
 PROC i_mov_hl                  ;MOV H,L    65
            mov  dh,dl
            jmp  com
 ENDP
 PROC i_mov_hm                  ;MOV H,M    66
            push di
            mov  di,dx
            call [cs:rb]
            mov  dh,bh
            pop  di
            jmp  com
 ENDP
 PROC i_mov_ha                  ;MOV H,A    67
            mov  dh,al
            jmp  com
 ENDP
 PROC i_mov_lb                  ;MOV L,B    68
            mov  bx,bp
            mov  dl,bh
            jmp  com
 ENDP
 PROC i_mov_lc                  ;MOV L,C    69
            mov  bx,bp
            mov  dl,bl
            jmp  com
 ENDP
 PROC i_mov_ld                  ;MOV L,D    6A
            mov  dl,ch
            jmp  com
 ENDP
 PROC i_mov_le                  ;MOV L,E    6B
            mov  dl,cl
            jmp  com
 ENDP
 PROC i_mov_lh                  ;MOV L,H    6C
            mov  dl,dh
            jmp  com
 ENDP
 PROC i_mov_lm                  ;MOV L,M    6E
            push di
            mov  di,dx
            call [cs:rb]
            mov  dl,bh
            pop  di
            jmp  com
 ENDP
 PROC i_mov_la                  ;MOV L,A    6F
            mov  dl,al
            jmp  com
 ENDP
 PROC i_mov_mb                  ;MOV M,B    70
            push di
            mov  bx,bp
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_mov_mc                  ;MOV M,C    71
            push di
            mov  bx,bp
            mov  bh,bl
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_mov_md                  ;MOV M,D    72
            push di
            mov  bh,ch
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_mov_me                  ;MOV M,E    73
            push di
            mov  bh,cl
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_mov_mh                  ;MOV M,H    74
            push di
            mov  bh,dh
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_mov_ml                  ;MOV M,L    75
            push di
            mov  bh,dl
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_hlt                     ;HLT        76
            cmp  [es:breac],0
            jz   i_hlt
            jmp  com
 ENDP
 PROC i_mov_ma                  ;MOV M,A    77
            push di
            mov  bh,al
            mov  di,dx
            call [cs:wb]
            pop  di
            jmp  com
 ENDP
 PROC i_mov_ab                  ;MOV A,B    78
            mov  bx,bp
            mov  al,bh
            jmp  com
 ENDP
 PROC i_mov_ac                  ;MOV A,C    79
            mov  bx,bp
            mov  al,bl
            jmp  com
 ENDP
 PROC i_mov_ad                  ;MOV A,D    7A
            mov  al,ch
            jmp  com
 ENDP
 PROC i_mov_ae                  ;MOV A,E    7B
            mov  al,cl
            jmp  com
 ENDP
 PROC i_mov_ah                  ;MOV A,H    7C
            mov  al,dh
            jmp  com
 ENDP
 PROC i_mov_al                  ;MOV A,L    7D
            mov  al,dl
            jmp  com
 ENDP
 PROC i_mov_am                  ;MOV A,M    7E
            push di
            mov  di,dx
            call [cs:rb]
            mov  al,bh
            pop  di
            jmp  com
 ENDP
 PROC i_add_b                   ;ADD B      80
            sahf
            mov  bx,bp
            add  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_add_c                   ;ADD C      81
            sahf
            mov  bx,bp
            add  al,bl
            lahf
            jmp  com
 ENDP
 PROC i_add_d                   ;ADD D      82
            sahf
            add  al,ch
            lahf
            jmp  com
 ENDP
 PROC i_add_e                   ;ADD E      83
            sahf
            add  al,cl
            lahf
            jmp  com
 ENDP
 PROC i_add_h                   ;ADD H      84
            sahf
            add  al,dh
            lahf
            jmp  com
 ENDP
 PROC i_add_l                   ;ADD L      85
            sahf
            add  al,dl
            lahf
            jmp  com
 ENDP
 PROC i_add_m                   ;ADD M      86
            push di
            mov  di,dx
            call [cs:rb]
            pop  di
            sahf
            add  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_add_a                   ;ADD A      87
            sahf
            add  al,al
            lahf
            jmp  com
 ENDP
 PROC i_adc_b                   ;ADC B      88
            sahf
            mov  bx,bp
            adc  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_adc_c                   ;ADC C      89
            sahf
            mov  bx,bp
            adc  al,bl
            lahf
            jmp  com
 ENDP
 PROC i_adc_d                   ;ADC D      8A
            lahf
            sahf
            adc  al,ch
            lahf
            jmp  com
 ENDP
 PROC i_adc_e                   ;ADC E      8B
            sahf
            adc  al,cl
            lahf
            jmp  com
 ENDP
 PROC i_adc_h                   ;ADC H      8C
            sahf
            adc  al,dh
            lahf
            jmp  com
 ENDP
 PROC i_adc_l                   ;ADC L      8D
            sahf
            adc  al,dl
            lahf
            jmp  com
 ENDP
 PROC i_adc_m                   ;ADC M      8E
            push di
            mov  di,dx
            call [cs:rb]
            pop  di
            sahf
            adc  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_adc_a                   ;ADC A      8F
            sahf
            adc  al,al
            lahf
            jmp  com
 ENDP
 PROC i_sub_b                   ;SUB B      90
            sahf
            mov  bx,bp
            sub  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_sub_c                   ;SUB C      91
            sahf
            mov  bx,bp
            sub  al,bl
            lahf
            jmp  com
 ENDP
 PROC i_sub_d                   ;SUB D      92
            sahf
            sub  al,ch
            lahf
            jmp  com
 ENDP
 PROC i_sub_e                   ;SUB E      93
            sahf
            sub  al,cl
            lahf
            jmp  com
 ENDP
 PROC i_sub_h                   ;SUB H      94
            sahf
            sub  al,dh
            lahf
            jmp  com
 ENDP
 PROC i_sub_l                   ;SUB L      95
            sahf
            sub  al,dl
            lahf
            jmp  com
 ENDP
 PROC i_sub_m                   ;SUB M      96
            push di
            mov  di,dx
            call [cs:rb]
            pop  di
            sahf
            sub  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_sub_a                   ;SUB A      97
            sahf
            sub  al,al
            lahf
            jmp  com
 ENDP
 PROC i_sbb_b                   ;SBB B      98
            sahf
            mov  bx,bp
            sbb  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_sbb_c                   ;SBB C      99
            sahf
            mov  bx,bp
            sbb  al,bl
            lahf
            jmp  com
 ENDP
 PROC i_sbb_d                   ;SBB D      9A
            sahf
            sbb  al,ch
            lahf
            jmp  com
 ENDP
 PROC i_sbb_e                   ;SBB E      9B
            sahf
            sbb  al,cl
            lahf
            jmp  com
 ENDP
 PROC i_sbb_h                   ;SBB H      9C
            sahf
            sbb  al,dh
            lahf
            jmp  com
 ENDP
 PROC i_sbb_l                   ;SBB L      9D
            sahf
            sbb  al,dl
            lahf
            jmp  com
 ENDP
 PROC i_sbb_m                   ;SBB M      9E
            push di
            mov  di,dx
            call [cs:rb]
            pop  di
            sahf
            sbb  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_sbb_a                   ;SBB A      9F
            sahf
            sbb  al,al
            lahf
            jmp  com
 ENDP
 PROC i_ana_b                   ;ANA B      A0  (or ah,10h ?)
            sahf
            mov  bx,bp
            and  al,bh
            lahf
            or   ah,10h
            jmp  com
 ENDP
 PROC i_ana_c                   ;ANA C      A1
            sahf
            mov  bx,bp
            and  al,bl
            lahf
            or   ah,10h
            jmp  com
 ENDP
 PROC i_ana_d                   ;ANA D      A2
            sahf
            and  al,ch
            lahf
            or   ah,10h
            jmp  com
 ENDP
 PROC i_ana_e                   ;ANA E      A3
            sahf
            and  al,cl
            lahf
            or   ah,10h
            jmp  com
 ENDP
 PROC i_ana_h                   ;ANA H      A4
            sahf
            and  al,dh
            lahf
            or   ah,10h
            jmp  com
 ENDP
 PROC i_ana_l                   ;ANA L      A5
            sahf
            and  al,dl
            lahf
            or   ah,10h
            jmp  com
 ENDP
 PROC i_ana_m                   ;ANA M      A6
            push di
            mov  di,dx
            call [cs:rb]
            pop  di
            sahf
            and  al,bh
            lahf
            or   ah,10h
            jmp  com
 ENDP
 PROC i_ana_a                   ;ANA A      A7
            sahf
            and  al,al
            lahf
            or   ah,10h
            jmp  com
 ENDP
 PROC i_xra_b                   ;XRA B      A8  (and ah,0FEh ?)
            sahf
            mov  bx,bp
            xor  al,bh
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_xra_c                   ;XRA C      A9
            sahf
            mov  bx,bp
            xor  al,bl
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_xra_d                   ;XRA D      AA
            sahf
            xor  al,ch
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_xra_e                   ;XRA E      AB
            sahf
            xor  al,cl
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_xra_h                   ;XRA H      AC
            sahf
            xor  al,dh
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_xra_l                   ;XRA L      AD
            sahf
            xor  al,dl
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_xra_m                   ;XRA M      AE
            push di
            mov  di,dx
            call [cs:rb]
            pop  di
            sahf
            xor  al,bh
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_xra_a                   ;XRA A      AF
            sahf
            xor  al,al
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_ora_b                   ;ORA B      B0  (and ah,0FEh ?)
            sahf
            mov  bx,bp
            or   al,bh
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_ora_c                   ;ORA C      B1
            sahf
            mov  bx,bp
            or   al,bl
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_ora_d                   ;ORA D      B2
            sahf
            or   al,ch
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_ora_e                   ;ORA E      B3
            sahf
            or   al,cl
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_ora_h                   ;ORA H      B4
            sahf
            or   al,dh
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_ora_l                   ;ORA L      B5
            sahf
            or   al,dl
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_ora_m                   ;ORA M      B6
            push di
            mov  di,dx
            call [cs:rb]
            pop  di
            sahf
            or   al,bh
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_ora_a                   ;ORA A      B7
            sahf
            or   al,al
            lahf
            and  ah,0FEh
            jmp  com
 ENDP
 PROC i_cmp_b                   ;CMP B      B8
            sahf
            mov  bx,bp
            cmp  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_cmp_c                   ;CMP C      B9
            sahf
            mov  bx,bp
            cmp  al,bl
            lahf
            jmp  com
 ENDP
 PROC i_cmp_d                   ;CMP D      BA
            lahf
            sahf
            cmp  al,ch
            lahf
            jmp  com
 ENDP
 PROC i_cmp_e                   ;CMP E      BB
            sahf
            cmp  al,cl
            lahf
            jmp  com
 ENDP
 PROC i_cmp_h                   ;CMP H      BC
            sahf
            cmp  al,dh
            lahf
            jmp  com
 ENDP
 PROC i_cmp_l                   ;CMP L      BD
            sahf
            cmp  al,dl
            lahf
            jmp  com
 ENDP
 PROC i_cmp_m                   ;CMP M      BE
            push di
            mov  di,dx
            call [cs:rb]
            pop  di
            sahf
            cmp  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_cmp_a                   ;CMP A      BF
            sahf
            cmp  al,al
            lahf
            jmp  com
 ENDP
 PROC i_rnz                     ;RNZ        C0
            sahf
            jz @@r
            mov  di,si
            call rword
            mov  si,di
            mov  di,bx
   @@r:     jmp  com
 ENDP
 PROC i_pop_b                   ;POP B      C1
            xchg di,si
            call rword
            xchg di,si
            mov  bp,bx
            jmp  com
 ENDP
 PROC i_jnz                     ;JNZ nn     C2
            sahf
            jnz  @@r
            add  di,2
            jmp  com
  @@r:      call rword
            mov  di,bx
            jmp  com
 ENDP
 PROC i_jmp                     ;JMP nn     C3
            call rword
            mov  di,bx
            jmp  com
 ENDP
 PROC i_cnz                     ;CNZ nn     C4
            sahf
            jnz  @@r
            add  di,2
            jmp  com
   @@r:     call rword
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_push_b                  ;PUSH B     C5
            push di
            sub  si,2
            mov  bx,bp
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_adi                     ;ADI n      C6
            call [cs:rb]
            sahf
            add  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_rst0                    ;RST 0      C7
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            xor  di,di
            jmp  com
 ENDP
 PROC i_rz                      ;RZ         C8
            sahf
            jnz  @@r
            mov  di,si
            call rword
            mov  si,di
            mov  di,bx
   @@r:     jmp  com
 ENDP
 PROC i_ret                     ;RET        C9
            mov  di,si
            call rword
            mov  si,di
            mov  di,bx
            jmp  com
 ENDP
 PROC i_jz                      ;JZ nn      CA
            sahf
            jz   @@r
            add  di,2
            jmp  com
   @@r:     call rword
            mov  di,bx
            jmp  com
 ENDP
 PROC i_cz                      ;CZ nn      CC
            sahf
            jz   @@r
            add  di,2
            jmp  com
   @@r:     call rword
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_call                    ;CALL nn    CD
            call rword
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_aci                     ;ACI n      CE
            call [cs:rb]
            sahf
            adc  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_rst1                    ;RST 1      CF
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            mov  di,8h
            jmp  com
 ENDP
 PROC i_rnc                     ;RNC        D0
            sahf
            jc   @@r
            mov  di,si
            call rword
            mov  si,di
            mov  di,bx
   @@r:     jmp  com
 ENDP
 PROC i_pop_d                   ;POP D      D1
            xchg di,si
            call rword
            xchg di,si
            mov  cx,bx
            jmp  com
 ENDP
 PROC i_jnc                     ;JNC nn     D2
            sahf
            jnc  @@r
            add  di,2
            jmp  com
   @@r:     call rword
            mov  di,bx
            jmp  com
 ENDP
 PROC i_out                      ;OUT n     D3   empty command.
            inc  di
            jmp  com
 ENDP
 PROC i_cnc                     ;CNC nn     D4
            sahf
            jnc  @@r
            add  di,2
            jmp  com
   @@r:     call rword
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_push_d                  ;PUSH D     D5
            push di
            sub  si,2
            mov  bx,cx
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_sui                     ;SUI n      D6
            call [cs:rb]
            sahf
            sub  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_rst2                    ;RST 2      D7
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            mov  di,10h
            jmp  com
 ENDP
 PROC i_rc                      ;RC         D8
            sahf
            jnc  @@r
            mov  di,si
            call rword
            mov  si,di
            mov  di,bx
   @@r:     jmp  com
 ENDP
 PROC i_jc                      ;JC nn      DA
            sahf
            jc   @@r
            add  di,2
            jmp  com
   @@r:     call rword
            mov  di,bx
            jmp  com
 ENDP
 PROC i_in                      ;IN n       DB  empty command.
            mov  al,0E5h
            inc  di
            jmp  com
 ENDP
 PROC i_cc                      ;CC nn      DC
            sahf
            jc   @@r
            add  di,2
            jmp  com
   @@r:     call rword
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_sbi                     ;SBI n      DE
            call [cs:rb]
            sahf
            sbb al,bh
            lahf
            jmp  com
 ENDP
 PROC i_rst3                     ;RST 3     DF
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            mov  di,18h
            jmp  com
 ENDP
 PROC i_rpo                     ;RPO        E0
            sahf
            jpe  @@r
            mov  di,si
            call rword
            mov  si,di
            mov  di,bx
   @@r:     jmp  com
 ENDP
 PROC i_pop_h                   ;POP H      E1
            xchg di,si
            call rword
            xchg di,si
            mov  dx,bx
            jmp  com
 ENDP
 PROC i_jpo                     ;JPO nn     E2
            sahf
            jpo  @@r
            add  di,2
            jmp  com
   @@r:     call rword
            mov  di,bx
            jmp  com
 ENDP
 PROC i_xthl                   ;XTHL        E3
            push di
            mov  di,si
            call rword
            xchg bx,dx
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_cpo                     ;CPO nn     E4
            sahf
            jpo  @@r
            add  di,2
            jmp  com
   @@r:     call rword
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_push_h                  ;PUSH H    E5
            push di
            sub  si,2
            mov  bx,dx
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_ani                     ;ANI n      E6
            call [cs:rb]
            sahf
            and  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_rst4                    ;RST 4      E7
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            mov  di,20h
            jmp  com
 ENDP
 PROC i_rpe
            sahf                ;RPE        E8
            jpo  @@r
            mov  di,si
            call rword
            mov  si,di
            mov  di,bx
   @@r:     jmp  com
 ENDP
 PROC i_pchl                    ;PCHL       E9
            mov  di,dx
            jmp  com
 ENDP
 PROC i_jpe                     ;JPE nn     EA
            sahf
            jpe  @@r
            add  di,2
            jmp  com
   @@r:     call rword
            mov  di,bx
            jmp  com
 ENDP
 PROC i_xchg                    ;XCHG       EB
            xchg dx,cx
            jmp  com
 ENDP
 PROC i_cpe                     ;CPE nn     EC
            sahf
            jpe  @@r
            add  di,2
            jmp  com
   @@r:     call rword
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_xri                     ;XRI n      EE
            call [cs:rb]
            sahf
            xor  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_rst5                     ;RST 5     EF
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            mov  di,28h
            jmp  com
 ENDP
 PROC i_rp                      ;RP         F0
            sahf
            js   @@r
            mov  di,si
            call rword
            mov  si,di
            mov  di,bx
   @@r:     jmp  com
 ENDP
 PROC i_pop_msw                 ;POP MSW    F1
            xchg di,si
            call rword
            xchg di,si
            mov  ax,bx
            jmp  com
 ENDP
 PROC i_jp                      ;JP  nn     F2
            sahf
            jns  @@r
            add  di,2
            jmp  com
   @@r:     call rword
            mov  di,bx
            jmp  com
 ENDP
 PROC i_di                      ;DI         F3
            mov  [es:Icon.iff],0
            jmp  com
 ENDP
 PROC i_cp                      ;CP nn      F4
            sahf
            jns  @@r
            add  di,2
            jmp  com
   @@r:     call rword
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_push_msw                ;PUSH MSW   F5
            push di
            sub  si,2
            mov  bx,ax
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_ori                     ;ORI n      F6
            call [cs:rb]
            sahf
            or   al,bh
            lahf
            jmp  com
 ENDP
 PROC i_rst6                    ;RST 6      F7
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            mov  di,30h
            jmp  com
 ENDP
 PROC i_rm                      ;RM         F8
            sahf
            jns  @@r
            mov  di,si
            call rword
            mov  si,di
            mov  di,bx
   @@r:     jmp  com
 ENDP
 PROC i_sphl                    ;SPHL       F9
            mov  si,dx
            jmp  com
 ENDP
 PROC i_jm                      ;JM  nn     FA
            sahf
            js   @@r
            add  di,2
            jmp  com
   @@r:     call rword
            mov  di,bx
            jmp  com
 ENDP
 PROC i_ei                      ;EI         FB
            mov  [es:Icon.iff],0FFh
            cmp  [es:Icon.intirp],0
            jz   @@r
            or   [es:breac],SOFT
   @@r:     jmp  Critical
 ENDP
 PROC i_cm                      ;CM nn      FC
            sahf
            js   @@r
            add  di,2
            jmp  com
   @@r:     call rword
            push bx
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            pop  di
            jmp  com
 ENDP
 PROC i_cpi                     ;CPI n      FE
            call [cs:rb]
            sahf
            cmp  al,bh
            lahf
            jmp  com
 ENDP
 PROC i_rst7                    ;RST 7      FF
            sub  si,2
            mov  bx,di
            mov  di,si
            call wword
            mov  di,38h
            jmp  com
 ENDP
; *******************************************************************
