 MACRO Rram
            mov bh,[di]
            inc di
            ret
 EVEN
 ENDM

 MACRO Rrom
            mov bh,[es:di+rom]
            inc di
            ret
 EVEN
 ENDM

 MACRO Wram
            mov [di],bh
            inc di
            ret
 EVEN
 ENDM

 MACRO Moda num
            mov [cs:rb],offset rb&num
            mov [cs:wb],offset wb&num
            pop bx
            inc di
            sti
            ret
 ENDM

 MACRO Syst zero
 LOCAL e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,k1,k2,vgf1
            cmp di,zero+0BFh
            jnz e2
            mov [es:Sys.color],bh  ;COLOR mode register
            inc di
            ret
 e2:        cmp di,zero+0FBh
            jz  e3
            cmp di,zero+7Fh
            jz  e1
            inc di
            ret
           EVEN
 e3:        push ax                ;LUT table
            push bx
            push dx
            mov  dx,3DAh           ; CGA emulation mode of VGA card.
            in   al,dx
            mov  al,bh
            mov  bl,bh
            and  bx,0Fh
            mov  [es:bx+Sys.Lutset],al
            xchg al,bl
            shr  bx,1
            shr  bx,1
            shr  bx,1
            shr  bx,1
            mov  dx,3C0h           ; Store palette settings.
            out  dx,al             ; Select palette register.
            mov  al,[es:bx+Lut]
            out  dx,al             ; Assign color number.
            mov  al,32
            out  dx,al             ; Turn on display.
            pop  dx
            pop  bx
            pop  ax
            inc  di
            ret
           EVEN
 e1:        cli                    ;SYSTEM register (5 bits)
            push bx
            and  bh,7Ch
            mov  [es:Sys.sysreg],bh
            jnz  e4
            Moda 00
 e4:        cmp  bh,18h
            jnz  e5
            Moda 18
 e5:        cmp  bh,20h
            jnz  e6
            Moda 20
 e6:        cmp  bh,1Ch
            jnz  e7
            Moda 1C
 e7:        cmp  bh,14h
            jnz  e8
            Moda 14
 e8:        cmp  bh,40h
            jnz  e9
            Moda 40
 e9:        cmp  bh,6Ch
            jnz  e10
            Moda 6C
 e10:       cmp  bh,5Ch
            jnz  e11
            Moda 5C
 e11:       cmp  bh,3Ch
            jnz  e12
            Moda 3C
 e12:       or   [es:breac],NOM
            pop  bx
            inc  di
            sti
            ret
 EVEN
 ENDM

 MACRO Rio zero
 LOCAL e1,e2,e3,e5,e6,k1,k4
           cmp di,zero+400h
           jnc e1               ; CRT screen area.
           cmp di,zero+200h
           jc  e2               ; KEYBOARD area.
           cmp di,zero+300h
           jc  e3
           jmp Rport
          EVEN
 e3:       mov bh,0E5h          ; SYSTEM page.
           inc di
           ret
          EVEN
e2:        push di              ; Procedure Readkeys.
           push cx
           push si
           mov  cx,8
           xor  bh,bh
           mov  si,OFFSET keys
           test di,100h         ; Two key maps.
           jz   e5
           add  si,cx
 e5:       shr  di,1
           jnc  e6
           or   bh,[es:si]
 e6:       inc  si
           loop e5
           pop  si
           pop  cx
           pop  di
           inc  di
           ret
          EVEN
 e1:       push ax                        ;Procedure Readchar.(CRT)
           push di
           sub  di,zero+400h
           shl  di,1
           mov  ax,[es:Scr+di]
           mov  bh,[es:Par2.c]
           and  bh,30h
           cmp  bh,30h
           mov  bh,ah
           jnz  k1

           or   al,al
           jz   k4
           or   [es:Par2.a],8
           jmp  k1
 k4:       and  [es:Par2.a],not 8
 k1:       pop  di
           pop  ax
           inc  di
           ret
          EVEN
 ENDM

 MACRO Wio zero
 LOCAL e1,e2,k3,k5,loop16,loop8,j1
           cmp di,zero+200h
           jnc e1              ; CRT screen area
           cmp di,zero+100h
           jc  e2              ; SYSTEM area
           jmp Wport

 e1:       push ax             ; Procedure Writescreen.(CRT)
           push di
           mov  ah,bh
           sub  di,zero+200h
           mov  al,[es:Par2.a]
           shl  di,1
           and  al,8           ; char inversion if attr<>0.
           jz   k3
           mov  al,0FFh
 k3:       cmp  [es:Scr+di],ax
           jnz  k5
           pop  di
           pop  ax
           inc  di
           ret

 k5:       mov  [es:Scr+di],ax
           push bx                   ;Char procedure (plot char)
           push dx
           push ds
           mov  bx,ax
           mov  dx,di
           and  dx,780h
           and  di,7Eh
           shr  di,1
           shl  dx,1
           add  di,dx
           shl  dx,1
           shl  dx,1
           add  di,dx
           add  di,47*80+8           ; Find char address.

           mov  dx,3C4h
           mov  al,2h
           out  dx,al                ; Select Map Mask register.
           inc  dx
           mov  al,8h                ; Allow writes to #3 map.
           out  dx,al
           mov  ax,0A000h            ; VGA screen address space.
           mov  ds,ax

           push cx
           mov  ah,bl
           xor  bl,bl
           mov  cl,4h
           shr  bx,cl
           mov  cx,10h
 loop16:   mov  al,[es:bx+Chk]
           xor  al,ah
           mov  [di],al
           inc  bx
           add  di,80
           loop loop16
           pop  cx

           mov  al,0Fh               ; Restore contents of Map Mask.
           out  dx,al

           pop  ds
           pop  dx
           pop  bx
           pop  di
           pop  ax
           inc  di
           ret
          EVEN
 e2:       Syst zero                 ; Procedure Writesys.
 ENDM

 MACRO Rgr zero
 LOCAL fin1,e1,e2
            push ax
            push dx
            push di
            push ds
            mov  dx,0A000h           ; VGA screen address space.
            mov  ds,dx
            sub  di,zero
            mov  dx,di
            and  dx,3FC0h
            shr  dx,1
            shr  dx,1
            add  di,dx               ; Find relocated address.
            add  di,47*80+8

            mov  dx,3CEh             ; Graphic controller port address.
            mov  ah,[es:Sys.color]
            test ah,80h
            jnz  e1
            mov  al,4h
            out  dx,al               ; Select Read Map register.
            inc  dx
            xor  al,al
            test ah,10h
            jnz  fin1
            test ah,20h
            jz   e2
            mov  al,1h
            jmp  fin1
 e2:        mov  al,2h
 fin1:      out  dx,al               ; Map image into address space.
            mov  bh,[di]             ; Read data from image.
            pop  ds
            pop  di
            pop  dx
            pop  ax
            inc  di
            ret
           EVEN
 e1:        mov  al,7h
            out  dx,al               ; Select Color Masking Disable register.
            inc  dx
            inc  al
            out  dx,al               ; Disable #3 map from comparing.
            dec  dx

            mov  al,2
            out  dx,al               ; Select Color compare register.
            inc  dx
            push cx
            mov  cl,4h
            shr  ah,cl               ; Find Read color number (3 bits).
            pop  cx
            mov  al,ah
            out  dx,al
            dec  dx

            mov  al,5
            out  dx,al               ; Select Mode register.
            inc  dx
            mov  al,8h
            out  dx,al               ; Switch to Read Compare mode.

            mov  bh,[di]
            not  bh                  ; Invert compared data.

            xor  al,al
            out  dx,al               ; Restore simple read mode.
            pop  ds
            pop  di
            pop  dx
            pop  ax
            inc  di
            ret
 EVEN
 ENDM

 MACRO Wgr zero
 LOCAL e1,e2,e3
            push ax
            push dx
            push di
            push ds
            mov  dx,0A000h           ; VGA screen address space.
            mov  ds,dx
            sub  di,zero
            mov  dx,di
            and  dx,3FC0h
            shr  dx,1
            shr  dx,1
            add  di,dx               ; Find relocated address.
            add  di,47*80+8

            mov  ah,[es:Sys.color]   ; Color mode emulated register.
            mov  dx,3CEh             ; Graphic controller port address.
            mov  al,1h
            out  dx,al               ; Select Enable Set/Reset register.
            inc  dx
            mov  al,0Fh
            out  dx,al               ; Enable all planes.
            dec  dx

            mov  al,8h
            out  dx,al               ; Select Bit Mask register.
            inc  dx
            mov  al,bh
            out  dx,al               ; Write byte into register.
            dec  dx

            xor  al,al
            out  dx,al               ; Select Set/Reset register.
            inc  dx
            test ah,80h
            jnz  e1

            test ah,1h
            jz   e2
            mov  al,0Fh
 e2:        out  dx,al               ; Setup stored bit for each plane.
            dec  dx

            mov  dx,3C4h             ; Sequencer port address.
            mov  al,2h
            out  dx,al               ; Select Map Mask register.
            inc  dx
            mov  al,ah
            shr  al,1h
            and  al,7h
            xor  al,7h
            out  dx,al               ; Allow writes to selected planes.

 e3:        mov  al,[di]
            mov  [di],al             ; Update planes contents.

            mov  al,0Fh
            out  dx,al               ; Restore Map Mask register.

            mov  dx,3CEh             ; Graphic controller port address.
            mov  al,1h
            out  dx,al               ; Select Enable Set/Reset register.
            inc  dx
            xor  al,al
            out  dx,al               ; Disable all planes.
            dec  dx

            mov  al,8h
            out  dx,al               ; Select Bit Mask register.
            inc  dx
            mov  al,0FFh
            out  dx,al               ; Restore contents of register.

            pop  ds
            pop  di
            pop  dx
            pop  ax
            inc  di
            ret
           EVEN
 e1:        mov  al,ah
            shr  al,1h
            and  al,7h
            out  dx,al               ; Setup bit mask for planes.

            mov  dx,3C4h             ; Sequencer port address.
            mov  al,2h
            out  dx,al               ; Select Map Mask register.
            inc  dx
            mov  al,7h
            out  dx,al               ; Allow writes to #0,#1,#2 planes.
            jmp  e3
 EVEN
 ENDM

 MACRO Modemu num
            mov [rb],offset rb&num
            mov [wb],offset wb&num
            jmp sad
 ENDM
