; isr - interrupt emulation
; reset - computer reset
; key - keyboard emulation  (interrupt)
; clock - clock emulation   (interrupt)
; _startemu - start emulation
; finish - end of emulation

            ideal
            locals
            model small
            assume cs:@Code,ds:@Data,es:@Data

           dataseg
 noegavga   DB "Program runs only with EGA/VGA cards",13,10,24h
 nomem      DB "No enouth memory to run program",13,10,24h
 nofiles    DB "One of KORVET.ROM, KORVET.FNT, KORVET.CON is not avaliable.",13,10,24h
 romname    DB "korvet.rom",0
 fntname    DB "korvet.fnt",0
 conname    DB "korvet.con",0
 filename   DB "disk.bin",0
 loadsize  equ SECSIZE*10
 loadp     equ 0C380h
 startp    equ 0DA00h
 starts    equ 1Ch


           CODESEG
            INCLUDE "DEFINE.INC"
            INCLUDE "IOS.INC"
            INCLUDE "I8080.ASM"
            INCLUDE "PORT.ASM"
            INCLUDE "MODELS.ASM"
           EVEN
 roms       DW @Data            ; address of ROM segment.
 rb         DW 0                ; Read procedure address.
 wb         DW 0                ; Write procedure address.

 PROC reset                     ; Executed when RESET is pressed.
            xor  ax,ax
            xor  cx,cx
            xor  dx,dx
            xor  bp,bp
            xor  si,si
            xor  di,di
            push cs
            pop  ds
            mov  es,[roms]
            mov  [rb],OFFSET rb00
            mov  [wb],OFFSET wb00
            mov  [es:Sys.sysreg],al
            mov  [es:Icon.iff],al
            mov  [es:breac],al
            mov  ds,[es:rams]
            jmp  Critical
           EVEN
 ENDP

 PROC key                       ; Keyboard handler.
            push ax
            push bx
            push ds
            mov  ds,[cs:roms]
            in   al,60h
            cmp  al,RSTKEY
            mov  ah,NOR
            jz   @@4
            cmp  al,QUITKEY
            mov  ah,NOQ
            jz   @@4
            xor  bh,bh
            shl  al,1
            mov  bl,al
            mov  ax,[keytab+bx]
            mov  bl,al
            jc   @@1
            or   [keys+bx],ah
            jmp  @@5
 @@1:       not  ah
            and  [keys+bx],ah
 @@5:       pop  ds
            pop  bx
            mov  al,20h
            out  20h,al
            pop  ax
            iret
 @@4:       or   [breac],ah
            jmp  @@5
           EVEN
 ENDP

 PROC clock                     ; System clock handler.
            push ax
            push bx
            push ds
            mov  al,10h
            mov  ds,[cs:roms]
            mov  ah,[Timer.com]
            cmp  [Timer.state],0
            jz   @@g1
            mov  bx,[Timer.ce]
            test ah,1
            jz   @@g2
            push ax
            sub  bl,1
            pushf
            mov  al,bl
            das
            mov  bl,al
            popf
            sbb  bh,0
            pushf
            mov  al,bh
            das
            mov  bh,al
            popf
            pop  ax
            jmp  @@g3
 @@g2:      sub  bx,1
 @@g3:      mov  [Timer.ce],bx
            jnc  @@g1
            mov  bx,[Timer.cw]
            mov  [Timer.ce],bx
            or   al,20h
            and  ah,0Ch
            cmp  ah,4h
            jz   @@g1
            mov  [Timer.state],0h
 @@g1:      not  al
            or   al,[Icon.intmsk]
            not  al
            or   [Icon.intirp],al
            and  al,[Icon.iff]
            jz   @@x
            or   [breac],SOFT
 @@x:       pop  ds             ;Interrupt is blocked.
            pop  bx
            mov  al,20h
            out  20h,al
            pop  ax
            iret
           EVEN
 ENDP

 PROC _startemu
            push ax
            push bx
            push cx
            push dx
            push si
            push di
            push bp
            pushf
            push es
            push ds
            mov  ax,3508h
            int  21h            ;interrupt address of clock
            push es
            push bx
            mov  ax,3509h
            int  21h            ;interrupt address of keyboard
            push es
            push bx
            mov  es,[cs:roms]
            mov  ds,[es:rams]
            mov  [es:breac],0
            mov  ax,[es:Cpu.afr.x]
            mov  bp,[es:Cpu.bcr.x]
            mov  cx,[es:Cpu.der.x]
            mov  dx,[es:Cpu.hlr.x]
            mov  si,[es:Cpu.spr.x]
            mov  di,[es:Cpu.pcr.x]

            push ds
            push cs
            pop  ds
            mov  bh,[es:Sys.sysreg]
            and  bh,7Ch  ; SYSTEM register (5 bits)
            jnz  gd4
            Modemu 00
 gd4:       cmp  bh,18h
            jnz  g5
            Modemu 18
 g5:        cmp  bh,20h
            jnz  g6
            Modemu 20
 g6:        cmp  bh,1Ch
            jnz  g7
            Modemu 1C
 g7:        cmp  bh,14h
            jnz  g8
            Modemu 14
 g8:        cmp  bh,40h
            jnz  g9
            Modemu 40
 g9:        cmp  bh,6Ch
            jnz  g10
            Modemu 6C
 g10:       cmp  bh,5Ch
            jnz  g11
            Modemu 5C
 g11:       cmp  bh,3Ch
            jnz  g12
            Modemu 3C
 g12:       pop  ds
            or   [es:breac],NOM
            jmp  finish

 sad:        push ax
             push dx
             mov  ax,2508h
             mov  dx,offset clock
             int  21h            ;set interrupt address of clock
             mov  ax,2509h
             mov  dx,offset key
             int  21h            ;set interrupt address of keyboard
             pop  dx
             pop  ax
             pop  ds
             jmp  com

  Finish:    mov [es:Cpu.afr.x],ax
             mov [es:Cpu.bcr.x],bp
             mov [es:Cpu.der.x],cx
             mov [es:Cpu.hlr.x],dx
             mov [es:Cpu.spr.x],si
             mov [es:Cpu.pcr.x],di
             pop dx
             pop ds
             mov ax,2509h
             int 21h
             pop dx
             pop ds
             mov ax,2508h
             int 21h
             pop ds
             pop es
             popf
             pop bp
             pop di
             pop si
             pop dx
             pop cx
             pop bx
             pop ax
             ret
            EVEN
 ENDP

 PROC start
            mov bx,ss
            mov ax,cs
            sub bx,ax
            add bx,20h+(2000h/16)       ; Stack size in paragraphs
            mov ah,4Ah
            int 21h
            mov ah,48h
            mov bx,1000h
            int 21h
            jnc memx
            mov ax,3h
            int 10h
            mov ax,@Data
            mov ds,ax
            mov ah,9h
            mov dx,offset nomem
            int 21h
            mov ax,4C00h
            int 21h
  memx:     mov ds,[cs:roms]
            mov [rams],ax

            mov [Par2.a],8
            mov [Sys.color],13h
            mov [es:Icon.iff],0h
            mov [Cpu.pcr.x],STARTP
            mov [Sys.sysreg],STARTS

            call readfnt
            call readrom
            call readcon
            call readfile
            call egavga
            call clockset
            call _startemu

            mov  ah,49h
            mov  ds,[cs:roms]; Release memory block.
            mov  es,[rams]
            int  21h
            mov  bx,[fdc.handle]
            mov  ah,3Eh
            int  21h
            mov  al,0FFh     ; Restore clock settings.
            out  40h,al
            out  40h,al
            in   al,61h
            and  al,0FCh
            out  61h,al      ; Turn off sound.
            mov  ax,3h
            int  10h         ; Restore screen mode.
            mov  ax,4C00h
            int  21h         ; Exit from the program.
 ENDP

 PROC egavga
            mov ax,40h
            mov es,ax
            cmp [Byte Ptr es:87h],0FFh
            jnz ega
            mov ax,1200h
            mov bl,36h
            int 10h
            cmp al,12h
            jz vga
  err1:     mov ax,@Data
            mov ds,ax
            mov ah,09h
            mov dx,offset noegavga
            int 21h
            mov ax,4C00h
            int 21h
  ega:
  vga:      mov ax,1200h
            mov bl,10h
            int 10h
            cmp bh,1
            jz  err1
            or  bl,bl
            jz  err1
            mov ax,10h
            int 10h
            mov ax,500h
            int 10h
            ret
 ENDP

 PROC  readrom
            mov ax,3D00h
            mov dx,offset romname
            int 21h
            jc faul2
            mov  bx,ax
            mov  ah,3Fh
            mov  cx,6000h
            mov  dx,offset rom
            push ds
            mov  ds,[cs:roms]
            int 21h
            pop  ds
            jc   faul2
            mov  ah,3Eh
            int  21h
            ret
   faul2:   mov ax,@Data
            mov ds,ax
            mov ah,9h
            mov dx,offset nofiles
            int 21h
            mov ax,4C00h
            int 21h
 ENDP

 PROC readfnt
            mov ax,3D00h
            mov dx,offset fntname
            int 21h
            jc faul1
            mov bx,ax
            mov ah,3Fh
            mov cx,1000h
            mov dx,offset chk
            push ds
            mov  ds,[cs:roms]
            int  21h
            pop  ds
            jc   faul1
            mov  ah,3Eh
            int  21h
            ret
   faul1:   mov ax,@Data
            mov ds,ax
            mov ah,9h
            mov dx,offset nofiles
            int 21h
            mov ax,4C00h
            int 21h
 ENDP

 PROC readcon
            mov ax,3D00h
            mov dx,offset conname
            int 21h
            jc faul3
            mov bx,ax
            mov ah,3Fh
            mov cx,110h
            mov dx,offset keytab
            push ds
            mov  ds,[cs:roms]
            int  21h
            pop  ds
            jc   faul3
            mov  ah,3Eh
            int  21h
            ret
   faul3:   mov ax,@Data
            mov ds,ax
            mov ah,9h
            mov dx,offset nofiles
            int 21h
            mov ax,4C00h
            int 21h
 ENDP

 PROC  readfile
            mov ax,3D02h
            mov dx,offset filename
            int 21h
            jc  faul4
            mov  bx,ax
            mov  ah,3Fh
            mov  cx,LOADSIZE
            mov  dx,LOADP
            push ds
            mov  ds,[cs:roms]
            mov  [fdc.com],0h
            mov  [fdc.state],0h
            mov  [fdc.direct],0h
            mov  [fdc.handle],bx
            mov  ds,[rams]
            int  21h
            pop  ds
            jc   faul4
            ret
   faul4:   mov ax,@Data
            mov ds,ax
            mov ah,9h
            mov dx,offset nofiles
            int 21h
            mov ax,4C00h
            int 21h
 ENDP

 PROC clockset
            mov al,34h
            out 43h,al
            mov al,156
            out 40h,al
            mov al,93
            out 40h,al
            mov al,0B7h
            out 43h,al
            mov al,99h
            out 42h,al
            mov al,99h
            out 42h,al
            ret
 ENDP

            DATASEG
            PUBLIC Rams
            PUBLIC Rom,Chk,Keytab,Lut,Scr,Sys,Cpu
            PUBLIC Icon,Timer,Par0,Par1,Par2,Com0,Com1,Fdc
            PUBLIC breac
 Rom         DB 6000h DUP(?)
 Chk         DB 1000h DUP(?)
 Keytab      DW 80h   DUP(?)
 Lut         DB 10h   DUP(?)
 Scr         DW 400h  DUP(?)        ; Screen state.
 keys        DB 10h   DUP(?)        ; Key press state.
 Sys         Tsys  ?
 Cpu         Treg  ?
 Icon        Tint  ?
 Timer       Ttim  ?
 Par0        T8255 ?
 Par1        T8255 ?
 Par2        T8255 ?
 Com0        T8251 ?
 Com1        T8251 ?
 Fdc         Tfdc  ?
 rams        DW    ?
 breac       DB    ?

            STACK 2000h
            END   start
