; PART OF MEMORY MODELS

; Write to ROM has no effect (no RAM shadow).
; Reading from system page or empty ports return 0E5h.
; Ports on page are indentified by 8 bits.
; System register uses only 5 bits.

; Procedures rb??                    & wb??
;  in: di - address              in: di - address
; out: bh - data                     bh - data
;      di=di+1                  out: di=di+1

; *************************************************************************

 PROC rb00
           cmp di,4000h
           jc  @@1
           Rram
 @@1:      cmp di,3800h
           jnc @@2
           Rrom
 @@2:      Rio 3800h
          EVEN
 ENDP

 PROC wb00
           cmp di,4000h
           jc  @@1
           Wram
 @@2:      ret
 @@1:      cmp di,3A00h
           jc  @@2
           Wio 3A00h
          EVEN
 ENDP

 PROC rb18
           cmp di,4000h
           jnc @@1
           Rrom
 @@1:      cmp di,0F800h
           jnc @@2
           Rram
 @@2:      Rio 0F800h
          EVEN
 ENDP

 PROC wb18
           cmp di,4000h
           jc  @@1
           cmp di,0F800h
           jnc @@2
           Wram
 @@1:      ret
 @@2:      cmp di,0FA00h
           jc  @@1
           Wio 0FA00h
          EVEN
 ENDP

 PROC rb20
           cmp di,4000h
           jc  @@1
           cmp di,0C000h
           jnc @@2
           Rram
 @@1:      cmp di,3800h
           jnc @@3
           Rrom
 @@2:      Rgr 0C000h
 @@3:      Rio 3800h
          EVEN
 ENDP

 PROC wb20
           cmp di,4000h
           jnc  @@4
           jmp  @@1
  @@4:     cmp di,0C000h
           jnc @@2
           Wram
  @@2:     Wgr 0C000h
  @@3:     ret
  @@1:     cmp di,3A00h
           jc  @@3
           Wio 3A00h
          EVEN
 ENDP

 PROC rb40
           cmp di,6000h
           jnc @@1
           Rrom
   @@1:    cmp di,0F800h
           jnc @@2
           Rram
   @@2:    Rio 0F800h
          EVEN
 ENDP

 PROC wb40
           cmp di,6000h
           jc  @@1
           cmp di,0F800h
           jnc @@2
           Wram
   @@1:    ret
   @@2:    cmp di,0FA00h
           jc  @@1
           Wio 0FA00h
          EVEN
 ENDP

 PROC rb1C
           cmp di,0F800h
           jnc @@1
           Rram
 @@1:      Rio 0F800h
          EVEN
 ENDP


 PROC wb1C
           cmp di,0F800h
           jnc @@1
           Wram
 @@2:      ret
 @@1:      cmp di,0FA00h
           jc  @@2
           Wio 0FA00h
          EVEN
 ENDP

 PROC rb14
           cmp di,2000h
           jc  @@1
           cmp di,0F800h
           jnc @@2
           Rram
 @@1:      Rrom
 @@2:      Rio 0F800h
          EVEN
 ENDP


 PROC wb14
           cmp  di,2000h
           jc  @@1
           cmp di,0F800h
           jnc @@2
           Wram
 @@1:      ret
 @@2:      cmp di,0FA00h
           jc  @@1
           Wio 0FA00h
          EVEN
 ENDP

 PROC rb6C
 @@1:      cmp di,0BF00h
           jnc @@2
           Rram
 @@3:      mov bh,0E5h
           ret
 @@2:      cmp di,0C000h
           jc  @@3
           Rgr 0C000h
          EVEN
 ENDP


 PROC wb6C
           cmp di,0BF00h
           jnc @@2
           Wram
 @@3:      ret
 @@2:      cmp di,0C000h
           jnc @@4
           jmp @@1
 @@4:      Wgr  0C000h
 @@1:      Syst 0BF00h
          EVEN
 ENDP

 PROC rb5C
           cmp di,0FE00h
           jnc @@1
           Rram
 @@1:      cmp di,0FF00h
           jnc @@2
           jmp Rport
 @@2:      mov bh,0E5h
           ret
          EVEN
 ENDP


 PROC wb5C
           cmp di,0FE00h
           jnc @@1
           Wram
 @@1:      cmp di,0FF00h
           jnc @@2
           jmp Wport
 @@2:      Syst 0FF00h
          EVEN
 ENDP

 PROC rb3C
           cmp  di,4000h
           jnc  @@3
           Rram
 @@3:      cmp  di,8000h
           jc   @@4
           cmp  di,0FE00h
           jnc  @@1
           Rram
 @@4:      Rgr  4000h
 @@2:      mov  bh,0E5h
           ret
 @@1:      cmp  di,0FF00h
           jnc  @@2
           jmp  Rport
          EVEN
 ENDP


 PROC wb3C
           cmp  di,4000h
           jnc  @@4
           Wram
 @@4:      cmp  di,8000h
           jnc  @@6
           jmp  @@5
 @@6:      cmp  di,0FE00h
           jnc   @@1
           Wram
 @@1:      cmp  di,0FF00h
           jnc  @@2
           jmp  Wport
 @@2:      Syst 0FF00h
 @@5:      Wgr  4000h
           EVEN
 ENDP
