; READ PORT ARRAY.

 rd_sound: push ax
           in   al,42h
           mov  bh,al
           pop  ax
           pop  di
           inc  di
           ret

 rd_0:     mov bh,0
           pop di
           inc di
           ret

 rd_p0a:   mov bh,[es:Par0.a]
           pop di
           inc di
           ret

 rd_p0b:   mov bh,[es:Par0.b]
           pop di
           inc di
           ret

 rd_p0c:   mov bh,[es:Par0.c]
           pop di
           inc di
           ret

 rd_p0s:   mov bh,[es:Par0.mode]
           pop di
           inc di
           ret

 rd_c0d:   mov bh,[es:Com0.data]
           pop di
           inc di
           ret

 rd_c0s:   mov bh,04h
           pop di
           inc di
           ret

 rd_ftr:   mov  bh,[es:fdc.track]
           pop  di
           inc  di
           ret

 rd_fsec:  mov  bh,[es:fdc.sector]
           pop  di
           inc  di
           ret

 rd_c1d:   mov bh,[es:Com1.data]
           pop di
           inc di
           ret

 rd_c1s:   mov bh,04h
           pop di
           inc di
           ret

 rd_msk:   mov bh,[es:Icon.intmsk]
           pop di
           inc di
           ret

 rd_p1a:   mov bh,[es:Par1.a]
           pop di
           inc di
           ret

 rd_p1b:   mov bh,[es:Par1.b]
           pop di
           inc di
           ret

 rd_p1c:   mov bh,[es:Par1.c]
           pop di
           inc di
           ret

 rd_p1s:   mov bh,[es:Par1.mode]
           pop di
           inc di
           ret

 rd_p2b:   mov bh,[es:Par2.b]
           pop di
           inc di
           ret

 rd_p2c:   mov bh,[es:Par2.c]
           pop di
           inc di
           ret

 rd_p2s:   mov bh,[es:Par2.mode]
           pop di
           inc di
           ret

 PROC read2
           push ax
           mov  ax,[es:Timer.cr]
           test [es:Timer.com],40h
           mov  bh,ah
           jz   @@f1
           mov  bh,al
 @@f1:     test [es:Timer.com],20h
           jz   @@f2
           xor  [es:Timer.com],40h
 @@f2:     pop  ax
           pop  di
           inc  di
           ret
          EVEN
 ENDP

 PROC read28
           test [es:Icon.stat],1
           jnz  @@l
           mov  bh,[es:Icon.intirp]
           pop  di
           inc  di
           ret
    @@l:   mov  bh,[es:Icon.intisr]
           pop  di
           inc  di
           ret
 ENDP

 PROC rd_p2a
           mov  bh,[es:Par2.a]
           push ax
           push dx
           mov  dx,3DAh
           in   al,dx
           and  bh,not 2h
           and  al,8
           shr  al,1
           shr  al,1
           or   bh,al
           pop  dx
           pop  ax
           pop  di
           inc  di
           ret
 ENDP

; WRITE PORT ARRAY.

 wr_sound: push ax
           mov  al,bh
           out  42h,al
           pop  ax
           pop  di
           inc  di
           ret

 wr_p0a:   mov [es:Par0.a],bh
           pop di
           inc di
           ret

 wr_p0b:   mov [es:Par0.b],bh
           pop di
           inc di
           ret

 wr_p0c:   mov [es:Par0.c],bh
           pop di
           inc di
           ret

 wr_p0s:   mov [es:Par0.mode],bh
           pop di
           inc di
           ret

 wr_c0d:   mov [es:Com0.data],bh
           pop di
           inc di
           ret

 wr_ftr:   mov [es:fdc.track],bh
           pop di
           inc di
           ret

 wr_fsec:  mov [es:fdc.sector],bh
           pop di
           inc di
           ret

 wr_c1d:   mov [es:Com1.data],bh
           pop di
           inc di
           ret

 wr_p1a:   mov [es:Par1.a],bh
           pop di
           inc di
           ret

 wr_p1b:   mov [es:Par1.b],bh
           pop di
           inc di
           ret

 PROC wr_p1c
           mov  [es:Par1.c],bh
           push ax              ;Sound control.
           in   al,61h          ; bh:bit3=1 - on
           or   al,3h
           test bh,8h
           jnz  @@p
           and  al,not 3h
 @@p:      out  61h,al
           pop  ax
           pop  di
           inc  di
           ret
 ENDP

 PROC wr_p1s                    ; Why here ???
           mov [es:Par1.mode],bh
           push ax              ;Sound control.
           in   al,61h          ; bh:bit3=1 - on
           or   al,3h
           test bh,8h
           jnz  @@p
           and  al,not 3h
 @@p:     ;out  61h,al
           pop  ax
           pop  di
           inc  di
           ret
 ENDP

 wr_p2b:   mov [es:Par2.b],bh
           pop di
           inc di
           ret

 wr_p2s:   mov [es:Par2.mode],bh
           pop di
           inc di
           ret

 PROC write2
           push ax
           push bx
           xor  ax,ax
           mov  bl,[es:Timer.com]
           test bl,20h
           jz   @@f
           mov  ax,[es:Timer.cw]
           xor  [es:Timer.com],10h
   @@f:    test bl,10h
           jz   @@f1
           mov  al,bh
           mov  [es:Timer.cw],ax
           pop  bx
           pop  ax
           pop  di
           inc  di
           ret
   @@f1:   mov  ah,bh
           mov  [es:Timer.cw],ax
           pop  bx
           pop  ax
           pop  di
           inc  di
           ret
 EVEN
 ENDP

 PROC write3
           push ax
           test bh,0C0h
           jnz  @@f3
           mov  al,bh
           or   al,80h
           out  43h,al
 @@f4:     pop  ax
           pop  di
           inc  di
           ret
 @@f3:     test bh,80h
           jz   @@f4
           test bh,30h
           jnz  @@f5
           mov  ax,[es:Timer.ce]
           mov  [es:Timer.cr],ax
           pop  ax
           pop  di
           inc  di
           ret
 @@f5:     mov  al,40h
           or   al,bh
           test al,10h
           jnz  @@f6
           xor  al,al
 @@f6:     mov  [es:Timer.com],al
           mov  [es:Timer.state],1
           pop  ax
           pop  di
           inc  di
           ret
 EVEN
 ENDP

 PROC write28                             ;8259 interrupt controller !!!
           push bx
           test bh,10h
           jz   @@l
           cli
           mov  [Byte Ptr es:Icon.inta],bh; initiation command.
           mov  [es:Icon.intmsk],0FFh     ; all interrupts blocked.
           mov  [es:Icon.intisr],0h       ; no executed interrupts.
           mov  [es:Icon.intirp],0h       ; no waiting interrupts.
           and  [es:breac],not SOFT
           mov  [es:Icon.stat],2
           sti
           pop  bx
           pop  di
           inc  di
           ret
 @@l:      xor  bh,20h
           test bh,28h
           jnz  @@j1
           mov  bl,1                      ;EOI command.
           mov  bh,[es:Icon.intisr]
 @@lp:     test bh,bl
           jnz  @@un
           shl  bl,1
           jnc  @@lp
 @@un:     sub  [es:Icon.intisr],bl
           mov  bh,[es:Icon.intirp]       ; check for waiting calls.
           and  bh,[es:Icon.iff]
           jz   @@x
           or   [es:breac],SOFT
 @@x:      pop  bx
           pop  di
           inc  di
           ret
 @@j1:     xor  bh,0Ah                    ;Special command.
           test bh,0Ah
           jnz  @@r
           shr  [es:Icon.stat],1
           shr  bh,1
           rcl  [es:Icon.stat],1
 @@r:      pop  bx
           pop  di
           inc  di
           ret
 EVEN
 ENDP

 PROC write29                             ;8259 second port
           test [es:Icon.stat],2
           jnz  @@l
           mov  [es:Icon.intmsk],bh
           pop  di
           inc  di
           ret
 @@l:      mov  [(byte ptr es:Icon.inta)+1],bh
           and  [es:Icon.stat],0FCh
           pop  di
           inc  di
           ret
 EVEN
 ENDP

 PROC wr_p2c
           mov  [es:Par2.c],bh
           test bh,20h
           jnz  @@o
           or   [es:Par2.a],8h
           pop  di
           inc  di
           ret
     @@o:  test bh,10h
           jnz  @@f
           and  [es:Par2.a],not 8h
     @@f:  pop  di
           inc  di
           ret
 EVEN
 ENDP

 PROC f_seek                         ; in: bh - new track, cF=1 - error.
           mov  bl,12h               ; Seek Error & Index marker flags.
           jc   @@5
           sub  bh,[es:fdc.track]
           mov  bl,-1
           jz   @@1
           jc   @@2
           mov  bl,1
   @@2:    mov  [es:fdc.direct],bl
           add  [es:fdc.track],bh
   @@1:    mov  bl,02h               ; Index marker flag set.
   @@5:    cmp  [es:fdc.track],0h
           jnz  @@3
           or   bl,04h               ; Zero track flag.
   @@3:    test [es:fdc.com],08h
           jz   @@4
           or   bl,20h               ; Head pressed.
   @@4:    and  [es:fdc.state],not 3Fh
           or   [es:fdc.state],bl
           ret
 EVEN
 ENDP

 PROC f_ind                          ; Copy parameters to ind structure.
           mov bh,[es:Par2.b]
           and bh,10h
           jz  @@zero
           mov bh,1h
  @@zero:  mov [es:fdc.ind.side],bh
           mov bl,[es:fdc.track]
           mov bh,[es:fdc.sector]
           mov [es:fdc.ind.track],bl
           mov [es:fdc.ind.sector],bh
           mov [es:fdc.ind.seclen],SECIND
           ret
 EVEN
 ENDP

 PROC wr_fs
           push bx
           mov  [es:Fdc.com],bh
           test bh,80h
           jnz  @@ns
           and  bh,70h
           jnz  @@sm
           call f_seek               ; Seek to zero track.
  @@ret:   pop  bx
           pop  di
           inc  di
           ret
  @@sm:    and  bh,60h
           jnz  @@ss
           mov  bh,[es:fdc.data]
           call f_seek               ; Seek to track from data register.
           jmp  @@ret
  @@ss:    cmp  bh,20h
           jnz  @@st
           mov  bh,[es:fdc.track]
           add  bh,[es:fdc.direct]   ; Seek to same direction.
           clc
           call f_seek
           pop  bx
           pop  di
           inc  di
           ret
  @@st:    cmp  bh,40h
           jnz  @@sr
           mov  bh,[es:fdc.track]
           add  bh,1h
           call f_seek               ; Seek to next track.
           pop  bx
           pop  di
           inc  di
           ret
  @@sr:    mov  bh,[es:fdc.track]
           sub  bh,1h
           call f_seek               ; Seek to previous track.
           pop  bx
           pop  di
           inc  di
           ret

  @@ns:    test bh,40h
           jz   @@rw                 ; Read/write sectors.
           and  bh,30h
           jnz  @@nrw                ; Read indentifier.
  @@rw:    and  [es:fdc.state],not 3Fh
           mov  bl,[es:fdc.sector]
           mov  [es:fdc.mark],0h
           cmp  bl,SECTORS
           ja   @@er
           or   bl,bl
           jz   @@er
           or   [es:fdc.state],1h
           call f_ind
           pop  bx
           pop  di
           inc  di
           ret
  @@er:    or   [es:fdc.state],10h
           mov  [es:fdc.com],0h
           pop  bx
           pop  di
           inc  di
           ret

  @@nrw:   test bh,20h
           jz   @@fr
           and  [es:fdc.state],not 3Fh
           or   [es:fdc.state],1h
           pop  bx                   ; Read/Write track.
           pop  di
           inc  di
           ret

  @@fr:    and  [es:fdc.state],not 3Fh
           pop  bx                   ; Reset controller.
           pop  di
           inc  di
           ret
 EVEN
 ENDP

 PROC f_offs
           mov al,2*SECTORS
           mul [fdc.ind.track]
           add al,[fdc.ind.sector]
           adc ah,0h
           cmp [fdc.ind.side],0
           jz  @@sp
           add ax,SECTORS
   @@sp:   dec ax
           mov dx,ax
           mov cl,10
           shl dx,cl
           mov cl,6h
           shr ax,cl
           mov cx,ax
           mov ax,4200h
           mov bx,[fdc.handle]
           int 21h
           ret
 EVEN
 ENDP

 PROC wr_fdta
           push ax
           mov  [es:fdc.data],bh     ; Store written byte.
           mov  al,[es:fdc.com]
           and  al,0E0h
           cmp  al,0A0h              ; Test if 'write sector' in progress.
           jnz  @@v
           mov  di,[es:fdc.mark]
           and  [es:fdc.state],not 2h
           mov  [es:di+fdc.buffer],bh; Store written byte in the buffer.
           inc  [es:fdc.mark]
           cmp  di,SECSIZE-1         ; Test if last byte in the sector.
           jc   @@v
           and  [es:fdc.state],not 3Fh
           push bx
           push cx
           push dx
           push ds
           push es
           pop  ds
           call f_offs
           mov  ah,40h
           mov  cx,SECSIZE
           mov  dx,offset fdc.buffer
           int  21h
           jc   @@er
           cmp  ax,cx
           jnc  @@ok
  @@er:    or   [fdc.state],20h      ; Write Error flag.
  @@ok:    pop  ds
           pop  dx
           pop  cx
           pop  bx
           test [es:fdc.com],10h     ; Test if multiple sector operation.
           mov  [es:fdc.com],0h      ; Set command completed flags.
           jz   @@v
           inc  [es:fdc.ind.sector]  ; Test if next sector is valid.
           cmp  [es:fdc.ind.sector],SECTORS
           ja   @@nss
           mov  [es:fdc.com],0B0h    ; Setup new operation of writing.
           or   [es:fdc.state],1h
           mov  [es:fdc.mark],0h
           jmp  @@v
  @@nss:   or   [es:fdc.state],10h   ; Sector Not Found flag.
  @@v:     pop  ax
           pop  di
           inc  di
           ret
 EVEN
 ENDP

 PROC rd_fdta
           push ax
           mov  bh,[es:fdc.data]     ; Read byte from register.
           mov  al,[es:fdc.com]
           xor  al,80h
           test al,0E0h              ; Test if 'read sector' in progress.
           jz   @@rds
           xor  al,40h
           test al,0F0h
           jnz  @@v1
           jmp  @@ri
  @@v1:    pop  ax
           pop  di
           inc  di
           ret
  @@rds:   cmp  [es:fdc.mark],0h
           jnz  @@r
           push bx
           push cx
           push dx
           push ds
           push es
           pop  ds
           call f_offs
           mov  ah,3Fh
           mov  cx,SECSIZE
           mov  dx,offset fdc.buffer
           int  21h
           pop  ds
           pop  dx
           pop  cx
           pop  bx
  @@r:     mov  di,[es:fdc.mark]
           and  [es:fdc.state],not 2h
           mov  bh,[es:di+fdc.buffer]
           mov  [es:fdc.data],bh
           inc  [es:fdc.mark]
           cmp  di,SECSIZE-1
           jc   @@v
           and  [es:fdc.state],not 3Fh
           test [es:fdc.com],10h     ; Set command completed flags.
           mov  [es:fdc.com],0h      ; Test if multiple sector operation.
           jz   @@v
           inc  [es:fdc.ind.sector]  ; Test if next sector is valid.
           cmp  [es:fdc.ind.sector],SECTORS
           ja   @@nss
           mov  [es:fdc.mark],0h
           mov  [es:fdc.com],90h     ; Setup new operation of writing.
           or   [es:fdc.state],1h
           jmp  @@v
  @@nss:   or   [es:fdc.state],10h   ; Sector Not Found flag.
  @@v:     pop  ax
           pop  di
           inc  di
           ret

  @@ri:    mov  di,[es:fdc.mark]
           and  [es:fdc.state],not 2h
           mov  bh,[byte ptr es:di+fdc.ind]
           mov  [es:fdc.data],bh
           inc  [es:fdc.mark]
           cmp  di,(SIZE Tind)-1
           jc   @@v
           and  [es:fdc.state],not 3Fh
           mov  [es:fdc.com],0h
           pop  ax
           pop  di
           inc  di
           ret

 EVEN
 ENDP

 PROC rd_fs
           mov  bh,[es:fdc.state]
           test bh,1h
           jz   @@no
           test bh,2h
           jz   @@cl
           dec  [es:fdc.count]
           jnz   @@no
           and  [es:fdc.state],not 3Fh
           or   [es:fdc.state],4h
           mov  [es:fdc.com],0h
           xor  bh,bh
           pop  di
           inc  di
           ret
   @@cl:   or   [es:fdc.state],2h
           mov  [es:fdc.count],2h
   @@no:   pop  di
           inc  di
           ret
 EVEN
 ENDP

; 64 READ AND WRITE PROCEDURES ( R/W PORTS ).
; Include into korvet.asm
 PROC  Rport
            push di
            shl  di,1
            and  di,1FEh
            jmp  [cs:di+@@rp]
  @@w:      mov  bh,0E5h
            pop  di
            inc  di
            ret
           EVEN
  @@rp     dw offset rd_sound   ;8253 sound port 0         [0h]
           dw offset rd_0       ;8253 net port (empty)
           dw offset read2      ;8253 clock port
           dw offset rd_0       ;8253 system port
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset rd_p0a     ;8255 (empty)              [8h]
           dw offset rd_p0b
           dw offset rd_p0c
           dw offset rd_p0s
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset rd_c0d     ;8251 data port            [10h]
           dw offset rd_c0s     ;8251 status port (empty)
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset rd_fs      ;8293 FDC status           [18h]
           dw offset rd_ftr     ;8293 FDC track
           dw offset rd_fsec    ;8293 FDC sector
           dw offset rd_fdta    ;8293 FDC data
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset rd_c1d     ;8251 data                 [20h]
           dw offset rd_c1s     ;8251 status (empty)
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset read28     ;8259 interrupt controller [28h]
           dw offset rd_msk     ;8259 interrupt mask
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset rd_p1a     ;8255 data printer (empty) [30h]
           dw offset rd_p1b
           dw offset rd_p1c
           dw offset rd_p1s
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset rd_p2a     ;8255 CRT refresh          [38h]
           dw offset rd_p2b     ;Drive register (empty)
           dw offset rd_p2c     ;CRT control
           dw offset rd_p2s
          REPT 196
           dw offset @@w
          ENDM
 ENDP

 PROC  Wport
            push di
            shl  di,1
            and  di,1FEh
            jmp  [cs:di+@@wp]
  @@w:      pop  di
            inc  di
            ret
           EVEN
  @@wp     dw offset wr_sound   ;8253 sound port 0         [0h]
           dw offset @@w        ;8253 net port (empty)
           dw offset write2     ;8253 clock port
           dw offset write3     ;8253 system port
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset wr_p0a     ;8255 (empty)              [8h]
           dw offset wr_p0b
           dw offset wr_p0c
           dw offset wr_p0s
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset wr_c0d     ;8251 data port            [10h]
           dw offset @@w        ;8251 status port (empty)
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset wr_fs      ;8293 FDC status           [18h]
           dw offset wr_ftr     ;8293 FDC track
           dw offset wr_fsec    ;8293 FDC sector
           dw offset wr_fdta    ;8293 FDC data
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset wr_c1d     ;8251 data                 [20h]
           dw offset @@w        ;8251 status (empty)
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset write28    ;8259 interrupt controller [28h]
           dw offset write29    ;8259 interrupt mask
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset wr_p1a     ;8255 data printer (empty) [30h]
           dw offset wr_p1b
           dw offset wr_p1c
           dw offset wr_p1s
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w
           dw offset @@w        ;8255 Read/Only            [38h]
           dw offset wr_p2b     ;Drive register (empty)
           dw offset wr_p2c     ;CRT control
           dw offset wr_p2s
          REPT 196
           dw offset @@w
          ENDM
 ENDP
